from typing import Any

from google.auth import credentials as credentials, exceptions as exceptions, jwt as jwt
from google.auth.transport.requests import AuthorizedSession as AuthorizedSession

class Credentials(credentials.CredentialsWithQuotaProject, credentials.Signing):
    token: Any
    expiry: Any
    def __init__(
        self,
        source_credentials,
        target_principal,
        target_scopes,
        delegates: Any | None = ...,
        lifetime=...,
        quota_project_id: Any | None = ...,
        iam_endpoint_override: Any | None = ...,
    ) -> None: ...
    def refresh(self, request) -> None: ...
    def sign_bytes(self, message): ...
    @property
    def signer_email(self): ...
    @property
    def service_account_email(self): ...
    @property
    def signer(self): ...
    def with_quota_project(self, quota_project_id): ...

class IDTokenCredentials(credentials.CredentialsWithQuotaProject):
    def __init__(
        self,
        target_credentials,
        target_audience: Any | None = ...,
        include_email: bool = ...,
        quota_project_id: Any | None = ...,
    ) -> None: ...
    def from_credentials(
        self, target_credentials, target_audience: Any | None = ...
    ): ...
    def with_target_audience(self, target_audience): ...
    def with_include_email(self, include_email): ...
    def with_quota_project(self, quota_project_id): ...
    token: Any
    expiry: Any
    def refresh(self, request) -> None: ...
